package com.sts.businesspanel;

import java.text.BreakIterator;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import org.json.JSONArray;
import org.json.JSONStringer;

import com.sts.businesspanel.arquitectura.rest.RESTClient;
import com.sts.businesspanel.customcontrols.Buscador;
import com.sts.businesspanel.customcontrols.Buscador.OnDragBuscadorListener;
import com.sts.businesspanel.customcontrols.Buscador.OnTouchBuscadorListener;
import com.sts.businesspanel.customcontrols.Contador;
import com.sts.businesspanel.customcontrols.Contador.OnDragContadorListener;
import com.sts.businesspanel.customcontrols.Contador.OnTouchContadorListener;
import com.sts.businesspanel.customcontrols.Grafico;
import com.sts.businesspanel.customcontrols.Grafico.OnDragGraficoListener;
import com.sts.businesspanel.customcontrols.Grafico.OnTouchGraficoListener;
import com.sts.businesspanel.customcontrols.MyDragShadowBuilder;
import com.sts.businesspanel.entities.BuscadorEntity;
import com.sts.businesspanel.entities.ConfiguracionWidget;
import com.sts.businesspanel.entities.ContadorEntity;
import com.sts.businesspanel.entities.DatosUsuario;
import com.sts.businesspanel.entities.DetalleComercial;
import com.sts.businesspanel.entities.DetalleComercialAdapter;
import com.sts.businesspanel.entities.DetalleTienda;
import com.sts.businesspanel.entities.DetalleTiendaAdapter;
import com.sts.businesspanel.entities.GraficoEntity;

import android.os.Bundle;
import android.os.Handler;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.ClipData;
import android.content.DialogInterface;
import android.content.Intent;
import android.view.DragEvent;
import android.view.Menu;
import android.view.View;
import android.view.View.OnDragListener;
import android.view.View.OnLongClickListener;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import android.widget.AdapterView.OnItemClickListener;

public class Panel extends Activity {

	private DatosUsuario datosUsuario;
	private ArrayList<ConfiguracionWidget> datosConfiguracion;
	private final static String SERVICE_URI = "http://217.76.135.234:81/BusinessPanelService";
	private DetalleComercial[] comerciales;
	private DetalleTienda[] tiendas;
	private String TipoComercial;
	private Boolean isValid;
	private String pattern;
	private Contador contadorComerciales;
	private Contador contadorVentasTiendas;
	private Buscador buscadorComerciales;
	private Grafico graficoVentas;
	private RelativeLayout rl;
	private int idOrigen = 0;
	
	final Handler mHandler = new Handler();
	
	protected void LlamarGuardarConfiguracion(){
		Thread t = new Thread() {
            public void run() {
            	isValid = GuardarConfiguracion();
            }
        };
        t.start();
	}
	
	protected Boolean GuardarConfiguracion(){
		Boolean datosCorrectos = false;
    	try {
            RESTClient rClient = new RESTClient(SERVICE_URI);
           
            String metodo = "ObtenerComercialesConectados";
           
            String conf = "";
            StringBuilder sb = new StringBuilder();
            sb.append("{");
            
            sb.append("\"Usuario\":\"" + datosUsuario.getUsuario() + "\",");
            sb.append("\"Password\":\"" + datosUsuario.getPassword() + "\",");
            sb.append("\"Orden\": [");
            
            for (ConfiguracionWidget item : datosConfiguracion) {
            	
            	sb.append("{");	
            	sb.append("\"Key\" : " + item.getId() + ",");
            	sb.append("\"Value\" : " + item.getOrden() + "");
            	sb.append("},");
            }
            
            sb.replace(sb.length() - 1, sb.length(), "");
            
            sb.append("]");
            
            sb.append("}");
            
            String json = sb.toString();
            
            
            rClient.webInvoke("GuardarConfiguracion", json, "application/json");
            
            
        } catch(Exception e){
            e.toString();
        }
    	return datosCorrectos;
	}
	
    protected void LlamarServicioComerciales() {
        Thread t = new Thread() {
            public void run() {
            	isValid = ObtenerComerciales();
                mHandler.post(ComercialesResult);
            }
        };
        t.start();
    }
    
    protected void LlamarServicioTiendas() {
        Thread t = new Thread() {
            public void run() {
            	isValid = ObtenerTiendas();
                mHandler.post(TiendasResult);
            }
        };
        t.start();
    }
    
    protected void LlamarObtenerComercialesPorValor() {
    	Thread t = new Thread() {
            public void run() {
            	isValid = ObtenerComercialesPorValor();
                mHandler.post(ComercialesValorResult);
            }
        };
        t.start();
	}
    
    private Boolean ObtenerTiendas(){
    	Boolean datosCorrectos = false;
    	try {
            RESTClient rClient = new RESTClient(SERVICE_URI);
            Map<String,String> params = new HashMap<String, String>();
            
            params.put("u",datosUsuario.getUsuario());
            params.put("p",datosUsuario.getPassword());
            
            String metodo = "ObtenerTiendasConVentas";
            
            if(TipoComercial.equals("Valor2")){
            	metodo = "ObtenerTiendasSinVentas";
            }
            
            String resultado = rClient.webGet(metodo, params);
            
            if(!resultado.isEmpty()){
            	datosCorrectos = true;
            	JSONArray jobj = new JSONArray(resultado);
            	tiendas = new DetalleTienda[jobj.length()];
            	
            	for (int i = 0; i < jobj.length(); ++i) {
            		DetalleTienda dc = new DetalleTienda();
                    dc.mail = jobj.getJSONObject(i).getString("Mail");
                    dc.nombre = jobj.getJSONObject(i).getString("Nombre");
                    dc.telefono = jobj.getJSONObject(i).getString("Telefono");
                    dc.responsable = jobj.getJSONObject(i).getString("Responsable");
                    
                    tiendas[i] = dc;    
                }
            }
            
        } catch(Exception e){
            e.toString();
        }
    	return datosCorrectos;
    }
    
    private Boolean ObtenerComerciales(){
    	Boolean datosCorrectos = false;
    	try {
            RESTClient rClient = new RESTClient(SERVICE_URI);
            Map<String,String> params = new HashMap<String, String>();
            
            params.put("u",datosUsuario.getUsuario());
            params.put("p",datosUsuario.getPassword());
            
            String metodo = "ObtenerComercialesConectados";
            
            if(TipoComercial.equals("Valor2")){
            	metodo = "ObtenerComercialesBaja";
            }
            
            String resultado = rClient.webGet(metodo, params);
            
            if(!resultado.isEmpty()){
            	datosCorrectos = true;
            	JSONArray jobj = new JSONArray(resultado);
            	comerciales = new DetalleComercial[jobj.length()];
            	
            	for (int i = 0; i < jobj.length(); ++i) {
                    DetalleComercial dc = new DetalleComercial();
                    dc.mail = jobj.getJSONObject(i).getString("Mail");
                    dc.nombre = jobj.getJSONObject(i).getString("Nombre");
                    dc.telefono = jobj.getJSONObject(i).getString("Telefono");
                    dc.tienda = jobj.getJSONObject(i).getString("Tienda");
                    
                    comerciales[i] = dc;    
                }
            }
            
        } catch(Exception e){
            e.toString();
        }
    	return datosCorrectos;
    }
    
    private Boolean ObtenerComercialesPorValor(){
    	Boolean datosCorrectos = false;
    	try {
            RESTClient rClient = new RESTClient(SERVICE_URI);
            Map<String,String> params = new HashMap<String, String>();
            
            params.put("u",datosUsuario.getUsuario());
            params.put("p",datosUsuario.getPassword());
            params.put("pattern",pattern);
            
            String metodo = "BuscarComercial";
            
            String resultado = rClient.webGet(metodo, params);
            
            if(!resultado.isEmpty()){
            	datosCorrectos = true;
            	JSONArray jobj = new JSONArray(resultado);
            	comerciales = new DetalleComercial[jobj.length()];
            	
            	for (int i = 0; i < jobj.length(); ++i) {
                    DetalleComercial dc = new DetalleComercial();
                    dc.mail = jobj.getJSONObject(i).getString("Mail");
                    dc.nombre = jobj.getJSONObject(i).getString("Nombre");
                    dc.telefono = jobj.getJSONObject(i).getString("Telefono");
                    dc.tienda = jobj.getJSONObject(i).getString("Tienda");
                    comerciales[i] = dc;    
                }
            }
            
        } catch(Exception e){
            e.toString();
        }
    	return datosCorrectos;
    }
    
    final Runnable ComercialesValorResult = new Runnable() {
        public void run() {
        	MostrarBuscadorResult();
        }
    };
    
    final Runnable ComercialesResult = new Runnable() {
        public void run() {
        	MostrarComerciales();
        }
    };
    
    final Runnable TiendasResult = new Runnable() {
		
		@Override
		public void run() {
			// TODO Auto-generated method stub
			MostrarTiendas();
		}
	};
    
	private void MostrarComerciales(){
    	DetalleComercialAdapter adapter = new DetalleComercialAdapter(this, R.layout.comercial_item_row, comerciales);
    	
    	final Dialog dialog = new Dialog(this, android.R.style.Theme_DeviceDefault_Light_Dialog_NoActionBar);
		dialog.setContentView(R.layout.dialog_detalle_comercial);
		ListView lv = (ListView)dialog.findViewById(R.id.listViewDetalleComercial);
    	lv.setAdapter(adapter);
    	
    	lv.setOnItemClickListener(new OnItemClickListener() {
			@Override
			public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
				// TODO Auto-generated method stub
				
			}
		});

		dialog.show();
    }

	private void MostrarTiendas(){
		DetalleTiendaAdapter adapter = new DetalleTiendaAdapter(this, R.layout.tienda_item_row, tiendas);
    	
    	final Dialog dialog = new Dialog(this, android.R.style.Theme_DeviceDefault_Light_Dialog_NoActionBar);
		dialog.setContentView(R.layout.dialog_detalle_tienda);
		ListView lv = (ListView)dialog.findViewById(R.id.listViewDetalleTienda);
    	lv.setAdapter(adapter);
    	
    	lv.setOnItemClickListener(new OnItemClickListener() {
			@Override
			public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
				// TODO Auto-generated method stub
				
			}
		});

		dialog.show();
	}
	
	private void MostrarBuscador(){
		final Dialog dialog = new Dialog(this, android.R.style.Theme_DeviceDefault_Light_Dialog_NoActionBar);
		dialog.setContentView(R.layout.dialog_buscar_comercial);
		Button b = (Button)dialog.findViewById(R.id.btBuscarComercial);
		b.setOnClickListener(new Button.OnClickListener() {
			public void onClick(View v) {
				EditText et = (EditText)dialog.findViewById(R.id.etBuscarComercial);
				pattern = et.getText().toString();
				LlamarObtenerComercialesPorValor();
				dialog.dismiss();
			}
		});
		
		dialog.show();
	}

	private void MostrarBuscadorResult(){
		if(comerciales.length == 1){
			String valor1 = comerciales[0].nombre;
			String valor2 = comerciales[0].tienda;
			String valor3 = comerciales[0].mail;
			String valor4 = comerciales[0].telefono;
			buscadorComerciales.SetValores(valor1, valor2, valor3, valor4);
		}
		else{
			DetalleComercialAdapter adapter = new DetalleComercialAdapter(this, R.layout.comercial_item_row, comerciales);
	    	
	    	final Dialog dialog = new Dialog(this, android.R.style.Theme_DeviceDefault_Light_Dialog_NoActionBar);
			dialog.setContentView(R.layout.dialog_detalle_comercial);
			ListView lv = (ListView)dialog.findViewById(R.id.listViewDetalleComercial);
	    	lv.setAdapter(adapter);
	    	
	    	lv.setOnItemClickListener(new OnItemClickListener() {
				@Override
				public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
					// TODO Auto-generated method stub
					String valor1 = comerciales[arg2].nombre;
					String valor2 = comerciales[arg2].tienda;
					String valor3 = comerciales[arg2].mail;
					String valor4 = comerciales[arg2].telefono;
					buscadorComerciales.SetValores(valor1, valor2, valor3, valor4);
					dialog.dismiss();
				}
			});

			dialog.show();
		}
	}
	
	private void MostrarGrafico(){
		
		//Grafico
        GraficoEntity confGrafico = new GraficoEntity();
        confGrafico.setTitle("Ventas");
        confGrafico.setEscala(2);
        confGrafico.setAutoRefresh(false);
        confGrafico.setUrlServicio(SERVICE_URI);
        confGrafico.setMetodo("ObtenerVentasMes");
        confGrafico.setUsuario(datosUsuario.getUsuario());
        confGrafico.setPassword(datosUsuario.getPassword());
        confGrafico.setMiliseconsUpdateInterval(3600000);//cada hora
        confGrafico.setMiliseconsStartInterval(1000);
        
        Grafico g = new Grafico(this, confGrafico, graficoVentas.getDatos());
        
        final Dialog dialog = new Dialog(this, android.R.style.Theme_DeviceDefault_Light_Dialog_NoActionBar);
        
        RelativeLayout.LayoutParams lp = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.WRAP_CONTENT,RelativeLayout.LayoutParams.WRAP_CONTENT);
        lp.width = 800;
        lp.height = 500;
        dialog.setContentView(g, lp);
        
        dialog.show();
	}
	
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Intent i = getIntent();
        datosUsuario = (DatosUsuario)i.getSerializableExtra(Login.DATOS_USUARIO);
        datosConfiguracion = (ArrayList<ConfiguracionWidget>) i.getSerializableExtra(Login.DATOS_CONFIGURACION);
        setContentView(R.layout.activity_panel);
    }

	@Override
	protected void onPostCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onPostCreate(savedInstanceState);
		
		rl = (RelativeLayout)findViewById(R.id.lyPanel);
		
		//Mostramos el mensaje de bienvenida
		TextView tvMensajeUsuario = (TextView)findViewById(R.id.tvMensajeUsuario);
        String strFormat=getString(R.string.tvMensajeUsuario);
        tvMensajeUsuario.setText(String.format(strFormat, datosUsuario.getNombre()));
        
        rl.setOnDragListener(new OnDragListener() {
			
			@Override
			public boolean onDrag(View v, DragEvent event) {
				// TODO Auto-generated method stub
				return DragDropManager(v, event);
			}
		});
        
        MostrarPanel();
	}
	
	private void MostrarPanel(){
		//Mostramos dinamicamente los controles
        
        int leftM = 0;
        int topM = 0;
        
        for (ConfiguracionWidget conf : datosConfiguracion) {
        	
    		switch (conf.getOrden()) {
			case 1:
				leftM = 25;
				topM = 45;
				break;
			case 2:
				leftM = 500;
				topM = 45;
				break;
			case 3:
				leftM = 25;
				topM = 320;
				break;
			case 4:		
				leftM = 500;
				topM = 320;
				break;
			default:
				break;
			}
        	
			if(conf.getId() == 1){
				
				//Contador comerciales
		        ContadorEntity confComerciales = new ContadorEntity();
		        confComerciales.setTitulo("Comerciales");
		        confComerciales.setContador1Titulo("Conectados");
		        confComerciales.setContador2Titulo("Bajas");
		        confComerciales.setUrlServicio(SERVICE_URI);
		        confComerciales.setMetodo("ObtenerDisponibilidadComerciales");
		        confComerciales.setUsuario(datosUsuario.getUsuario());
		        confComerciales.setPassword(datosUsuario.getPassword());
		        confComerciales.setMiliseconsUpdateInterval(60000);//cada minuto
		        confComerciales.setMiliseconsStartInterval(1000);//esperamos un segundo antes de recuperar los datos
		        
		        contadorComerciales = new Contador(this, confComerciales);
		        
		        RelativeLayout.LayoutParams lpComerciales = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.WRAP_CONTENT,RelativeLayout.LayoutParams.WRAP_CONTENT);
		        lpComerciales.leftMargin = leftM;
		        lpComerciales.topMargin = topM;
		        lpComerciales.addRule(RelativeLayout.BELOW, R.id.vwLineaRojaTitulo);
		        
		        contadorComerciales.setLayoutParams(lpComerciales);
		        
		        contadorComerciales.setOnTouchContadorListener(contadorComercialesListener);
		        contadorComerciales.setOnDragContadorListener(contadorComercialesLongClick);
		        //contadorComerciales.setOnDragListener(contadorComercialesDragListener);
		        
		        contadorComerciales.setId(conf.getId());
		        rl.addView(contadorComerciales);
		        
			}else if(conf.getId() == 2){
				
				//Contador ventas tiendas
		        ContadorEntity confVentasTiendas = new ContadorEntity();
		        confVentasTiendas.setTitulo("Ventas en tiendas");
		        confVentasTiendas.setContador1Titulo("Con ventas");
		        confVentasTiendas.setContador2Titulo("Sin ventas");
		        confVentasTiendas.setUrlServicio(SERVICE_URI);
		        confVentasTiendas.setMetodo("ObtenerVentasTotalesTiendas");
		        confVentasTiendas.setUsuario(datosUsuario.getUsuario());
		        confVentasTiendas.setPassword(datosUsuario.getPassword());
		        confVentasTiendas.setMiliseconsUpdateInterval(60000);//cada minuto
		        confVentasTiendas.setMiliseconsStartInterval(1000);//esperamos un segundo antes de recuperar los datos
		        
		        contadorVentasTiendas = new Contador(this, confVentasTiendas);

		        RelativeLayout.LayoutParams lpVentasTiendas = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.WRAP_CONTENT,RelativeLayout.LayoutParams.WRAP_CONTENT);
		        lpVentasTiendas.leftMargin = leftM;
		        lpVentasTiendas.topMargin = topM;
		        lpVentasTiendas.addRule(RelativeLayout.BELOW, R.id.vwLineaRojaTitulo);
		        contadorVentasTiendas.setLayoutParams(lpVentasTiendas);
		        
		        contadorVentasTiendas.setOnTouchContadorListener(contadorVentasTiendasListener);
		        contadorVentasTiendas.setOnDragContadorListener(contadorVentasLongClick);
		        //contadorVentasTiendas.setOnDragListener(contadorVentasDragListener);
		        
		        contadorVentasTiendas.setId(conf.getId());
		        rl.addView(contadorVentasTiendas);
		        
			}else if(conf.getId() == 3){
				
				//Buscador comerciales
		        BuscadorEntity confBuscadorEntity = new BuscadorEntity();
		        confBuscadorEntity.setBuscadorTitulo("Buscar comercial");
		        
		        buscadorComerciales = new Buscador(this, confBuscadorEntity);
		        
		        buscadorComerciales.setOnTouchBuscadorListener(buscadorListener);
		        buscadorComerciales.setOnDragBuscadorListener(buscadorComercialesLongClick);
		        //buscadorComerciales.setOnDragListener(buscadorComercialesDragListener);
		        
		        RelativeLayout.LayoutParams lpBuscador = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.WRAP_CONTENT,RelativeLayout.LayoutParams.WRAP_CONTENT);
		        lpBuscador.leftMargin = leftM;
		        lpBuscador.topMargin = topM;
		        lpBuscador.addRule(RelativeLayout.BELOW, R.id.vwLineaRojaTitulo);
		        buscadorComerciales.setLayoutParams(lpBuscador);
		        
		        buscadorComerciales.setId(conf.getId());
		        rl.addView(buscadorComerciales);
		        
			}else if(conf.getId() == 4){
				
				//Grafico
		        GraficoEntity confGrafico = new GraficoEntity();
		        confGrafico.setTitle("Ventas");
		        confGrafico.setEscala(1);
		        confGrafico.setAutoRefresh(true);
		        confGrafico.setUrlServicio(SERVICE_URI);
		        confGrafico.setMetodo("ObtenerVentasMes");
		        confGrafico.setUsuario(datosUsuario.getUsuario());
		        confGrafico.setPassword(datosUsuario.getPassword());
		        confGrafico.setMiliseconsUpdateInterval(3600000);//cada hora
		        confGrafico.setMiliseconsStartInterval(1000);//esperamos un segundo antes de recuperar los datos
		        
		        graficoVentas = new Grafico(this, confGrafico);
		        
		        RelativeLayout.LayoutParams lpGrafico = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.WRAP_CONTENT,RelativeLayout.LayoutParams.WRAP_CONTENT);
		        lpGrafico.leftMargin = leftM;
		        lpGrafico.topMargin = topM;
		        lpGrafico.addRule(RelativeLayout.BELOW, R.id.vwLineaRojaTitulo);
		        graficoVentas.setLayoutParams(lpGrafico);
		        
		        graficoVentas.setOnTouchGraficoListener(graficoListener);
		        graficoVentas.setOnDragGraficoListener(graficoLongClick);
		        //graficoVentas.setOnDragListener(graficoDragListener);
		        
		        graficoVentas.setId(conf.getId());
		        rl.addView(graficoVentas);
		        
			}
		}
	}
	
	private OnTouchGraficoListener graficoListener = new OnTouchGraficoListener(){
		@Override
		public void onTouchGraficoOccurred(View v) {
			MostrarGrafico();
		}
	};
	
	private OnTouchBuscadorListener buscadorListener = new OnTouchBuscadorListener() {
		@Override
		public void onTouchBuscadorOccurred(View v) {
			MostrarBuscador();
		}
	};

	private OnTouchContadorListener contadorComercialesListener = new OnTouchContadorListener() {
		@Override
		public void onTouchContadorOccurred(View v, String valor) {
			if(valor.equals("Valor1")){
				TipoComercial = "Valor1";
			}
			else{
				TipoComercial = "Valor2";
			}
			LlamarServicioComerciales();
		}
	};
    
	private OnTouchContadorListener contadorVentasTiendasListener = new OnTouchContadorListener() {

		@Override
		public void onTouchContadorOccurred(View v, String valor) {
			if(valor.equals("Valor1")){
				TipoComercial = "Valor1";
			}
			else{
				TipoComercial = "Valor2";
			}
			LlamarServicioTiendas();
		}
	};
	
	private void IniciarDragDrop(View v, int id){
		MyDragShadowBuilder sb = new MyDragShadowBuilder(v);
		ClipData.Item item = new ClipData.Item(String.valueOf(id));
		String[] mime = new String[1];
		mime[0] = "text/plain";
		ClipData dragData = new ClipData(String.valueOf(id), mime, item);
		v.startDrag(dragData, sb, null, 0);
	}
	
	private ConfiguracionWidget GetDragObject(int id){
		ConfiguracionWidget rtv = null;
		
		for (ConfiguracionWidget conf : datosConfiguracion) {
			if(conf.getId() == id){
				rtv = conf;
				break;
			}
		}
		
		return rtv;
	}
	
	private ConfiguracionWidget GetDragDestinoFromCoords(float x, float y){
		ConfiguracionWidget rtv = null;
		int order = 0;
		
		if(y < 450){
			if(x < 500){
				order = 1;
			}
			else{
				order = 2;
			}
		}
		else{
			if(x < 500){
				order = 3;
			}
			else{
				order = 4;
			}
		}
		
		for (ConfiguracionWidget conf : datosConfiguracion) {
			if(conf.getOrden() == order){
				rtv = conf;
				break;
			}
		}
		
		return rtv;
	}
	
	private Boolean DragDropManager(View v, DragEvent event){
		
		// Defines a variable to store the action type for the incoming event
        final int action = event.getAction();
        boolean rtv = true;
        
        switch(action) {
        	case DragEvent.ACTION_DRAG_STARTED:
        		//idOrigen = Integer.parseInt(event.getClipData().getItemAt(0).getText().toString());
        		break;
        		
        	case DragEvent.ACTION_DRAG_ENTERED:
        		
        		break;
        		
        	case DragEvent.ACTION_DRAG_LOCATION:
        		
        		break;
        		
        	case DragEvent.ACTION_DRAG_EXITED:
        		
        		break;
        		
        	case DragEvent.ACTION_DROP:
        		// Gets the item containing the dragged data
                ClipData.Item item = event.getClipData().getItemAt(0);

                // Gets the text data from the item.
                String dragData = item.getText().toString();
               
                float x = event.getX();
                float y = event.getY();
                
                ConfiguracionWidget origen = GetDragObject(idOrigen);
                ConfiguracionWidget destino = GetDragDestinoFromCoords(x, y);
                
                if(origen.getId() != destino.getId()) {
                
	                ArrayList<ConfiguracionWidget> nuevaConfiguracion = new ArrayList<ConfiguracionWidget>();
	                
	                int ordenOrigen = 0;
	                int ordenDestino = 0;
	                
	                for (ConfiguracionWidget conf : datosConfiguracion) {
	                	
	                	if(conf.getId() == destino.getId()){
	                		destino = conf;
	                	}
	                	else if(conf.getId() == origen.getId()){
	                		origen = conf;
	                	}
	                	else{
	                		nuevaConfiguracion.add(conf);
	                	}
	                }
	                
	                ordenOrigen = origen.getOrden();
	                ordenDestino = destino.getOrden();
	                
	                origen.setOrden(ordenDestino);
	                destino.setOrden(ordenOrigen);
	                nuevaConfiguracion.add(origen);
	                nuevaConfiguracion.add(destino);
	                
	                datosConfiguracion = nuevaConfiguracion;
	                
	                rl.removeView(contadorComerciales);
	                rl.removeView(contadorVentasTiendas);
	                rl.removeView(buscadorComerciales);
	                rl.removeView(graficoVentas);
	                
	                contadorComerciales = null;
	                contadorVentasTiendas = null;
	                buscadorComerciales = null;
	                graficoVentas = null;
	                
	                MostrarPanel();
                }
                
        		break;
        		
        	case DragEvent.ACTION_DRAG_ENDED:
        		LlamarGuardarConfiguracion();
        		break;
        }
        
        return rtv;
	}
	
	private OnDragContadorListener contadorComercialesLongClick = new OnDragContadorListener() {
		
		@Override
		public void onDragContadorOccurred(View v, int id) {
			idOrigen = id;
			IniciarDragDrop(v, id);
		}
	};
	
	private OnDragContadorListener contadorVentasLongClick = new OnDragContadorListener() {
		
		@Override
		public void onDragContadorOccurred(View v, int id) {
			idOrigen = id;
			IniciarDragDrop(v, id);
		}
	};
	
	private OnDragBuscadorListener buscadorComercialesLongClick = new OnDragBuscadorListener() {
		
		@Override
		public void OnDragBuscadorOccurred(View v, int id) {
			idOrigen = id;
			IniciarDragDrop(v, id);
		}
	};
	
	private OnDragGraficoListener graficoLongClick = new OnDragGraficoListener() {
		
		@Override
		public void OnDragGraficoOccurred(View v, int id) {
			idOrigen = id;
			IniciarDragDrop(v, id);
		}
	};
	
	
	@Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.activity_panel, menu);
        return true;
    }
    
    public void logoutOnClick(View v) {
    	final Intent intent = new Intent(this, Login.class);
    	
    	AlertDialog ad = new AlertDialog.Builder(this, android.R.style.Theme_DeviceDefault_Light_Dialog).create();
		ad.setCancelable(false); // para bloquear el boton de back del dispositivo
		ad.setTitle(getString(R.string.login_warning_title));
		ad.setMessage(getString(R.string.login_warning_mensaje_logout));
		ad.setButton(
				DialogInterface.BUTTON_NEGATIVE, getString(R.string.Warning_NO), new DialogInterface.OnClickListener() {
	    		    @Override
	    		    public void onClick(DialogInterface dialog, int which) {
	    		        dialog.dismiss();                    
	    		    }
	    		} 
		);
		ad.setButton(
				DialogInterface.BUTTON_POSITIVE, getString(R.string.Warning_SI), new DialogInterface.OnClickListener() {
	    		    @Override
	    		    public void onClick(DialogInterface dialog, int which) {
	    		    	startActivity(intent);               
	    		    }
	    		} 
		);
		ad.show();
	}
}
