package com.sts.businesspanel.arquitectura.rest;

import java.io.IOException;
import java.io.InputStream;
import java.util.Map;


public interface IRESTClient {
	/**
     * Metodo para invocar mediante POST
     * @param methodName : El nombre de la operacion
     * @param data : Los datos a enviar en formato JSON
     * @param contentType : El tipo de content type por ejemplo application/json
     * @return : Un string con la representacin JSON de la entidad resultante
     */
    String webInvoke(String methodName, String data, String contentType);

    /**
     * Metodo para invocar mediante POST
     * @param methodName : El nombre de la operacion
     * @param params : Parametros del metodo
     * @return : Un string con la representacin JSON de la entidad resultante
     */
    String webGet(String methodName, Map<String, String> params);

    /**
     * Obtenemos la peticin RAW de la url
     * @param urlString : Direccin URL
     * @return : El input stream originado por la respuesta
     * @throws IOException
     */
    InputStream getHttpStream(String urlString) throws IOException;

    void clearCookies();

    void abort();
}
