package com.sts.businesspanel.customcontrols;

import java.util.HashMap;
import java.util.Map;
import java.util.Timer;
import java.util.TimerTask;
import org.json.JSONException;
import org.json.JSONObject;
import com.sts.businesspanel.R;
import com.sts.businesspanel.arquitectura.rest.RESTClient;
import com.sts.businesspanel.entities.ContadorEntity;
import android.content.Context;
import android.content.res.TypedArray;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Paint.Align;
import android.graphics.Typeface;
import android.os.Handler;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.view.View;
import android.widget.PopupWindow;

public class Contador extends View {

	@Override
	public int getId() {
		// TODO Auto-generated method stub
		return Id;
	}

	@Override
	public void setId(int id) {
		// TODO Auto-generated method stub
		Id = id;
	}

	//Valores por defecto del control
	private final static int DEFAULT_WIDTH = 400;
	private final static int DEFAULT_HEIGHT = 250;
	
	//Pinceles para pintar los diferentes elementos
	private Paint rectanglePaint;
    private Paint lineaPaint;
    private Paint textTitlePaint;
    private Paint textContadorPaint;
    private Paint textValorPaint;
   
    //Campos
    private String title;
	private String contador_1_title;
	private String contador_2_title;
	private String usuario;
	private String password;
	private String urlServicio;
	private String metodo;
	private String Valor1;
	private String Valor2;
	private long MiliseconsUpdateInterval;
	private long MiliseconsStartInterval;
    private int Id;
	
	//Timer
	private Timer t;
	private Handler mHandler;
	
	private OnTouchContadorListener listener;
	private OnDragContadorListener dragListener;
	
	public interface OnTouchContadorListener {
        void onTouchContadorOccurred(View v, String valor);
	}
	
	public interface OnDragContadorListener{
		void onDragContadorOccurred(View v, int id);
	}
	
	public void setOnTouchContadorListener(OnTouchContadorListener l) {
        listener = l;
	}
	
	public void setOnDragContadorListener(OnDragContadorListener l) {
		dragListener = l;
	}

	public Contador(Context ctx, ContadorEntity conf) {
		super(ctx);
		
		title = conf.getTitulo();
		contador_1_title = conf.getContador1Titulo();
		contador_2_title = conf.getContador2Titulo();
		usuario = conf.getUsuario();
		password = conf.getPassword();
		urlServicio = conf.getUrlServicio();
		metodo = conf.getMetodo();
		Valor1 = "0";
		Valor2 = "0";
		MiliseconsUpdateInterval = conf.getMiliseconsUpdateInterval();
		MiliseconsStartInterval = conf.getMiliseconsStartInterval();
		mHandler = new Handler();
		t = new Timer();
		
		Init();
	}
	
	public Contador(Context ctx, AttributeSet attrs) {
        super(ctx, attrs);
        
    	TypedArray a = ctx.getTheme().obtainStyledAttributes(attrs, R.styleable.Contador, 0, 0);

    	try {
    		//TODO: Aqui setear las propiedades por ejemplo:
    		//mShowText = a.getBoolean(R.styleable.PieChart_showText, false);
    	} finally {
    		a.recycle();
    	}
    	
    	Init();
    }
	
	private void Init(){
		//Definimos las dimensiones
		setMeasuredDimension(DEFAULT_WIDTH, DEFAULT_HEIGHT);
		
		rectanglePaint = new Paint(Paint.ANTI_ALIAS_FLAG);
		rectanglePaint.setStyle(Paint.Style.FILL);
		rectanglePaint.setColor(Color.RED);
		
		lineaPaint = new Paint(Paint.ANTI_ALIAS_FLAG);
		lineaPaint.setStyle(Paint.Style.FILL);
		lineaPaint.setColor(Color.WHITE);
		lineaPaint.setStrokeWidth(3);
		
		Typeface tf = Typeface.create(Typeface.SERIF,Typeface.BOLD);
		textTitlePaint = new Paint(Paint.ANTI_ALIAS_FLAG);
		textTitlePaint.setStyle(Paint.Style.FILL);
		textTitlePaint.setColor(Color.WHITE);
		textTitlePaint.setTextSize(22);
		textTitlePaint.setTypeface(tf);
		textTitlePaint.setTextAlign(Align.CENTER);
		
		textContadorPaint = new Paint(Paint.ANTI_ALIAS_FLAG);
		textContadorPaint.setStyle(Paint.Style.FILL);
		textContadorPaint.setColor(Color.WHITE);
		textContadorPaint.setTextSize(16);
		textContadorPaint.setTextAlign(Align.CENTER);
		
		textValorPaint = new Paint(Paint.ANTI_ALIAS_FLAG);
		textValorPaint.setStyle(Paint.Style.FILL);
		textValorPaint.setColor(Color.WHITE);
		textValorPaint.setTextSize(40);
		textValorPaint.setTypeface(tf);
		textValorPaint.setTextAlign(Align.CENTER);
		
		t.scheduleAtFixedRate(new UpdateTimeTask(), MiliseconsStartInterval, MiliseconsUpdateInterval);
	}
	
	@Override
	protected void onDraw(Canvas canvas) {
		super.onDraw(canvas);
		canvas.drawRect(0, 0, 400, 250, rectanglePaint);
		
		canvas.drawLine(70, 130, 170, 130, lineaPaint);
		canvas.drawLine(230, 130, 330, 130, lineaPaint);
		
		canvas.drawText(title, 200, 30, textTitlePaint);
		canvas.drawText(contador_1_title, 120, 170, textContadorPaint);
		canvas.drawText(contador_2_title, 280, 170, textContadorPaint);
		canvas.drawText(Valor1, 120, 110, textValorPaint);
		canvas.drawText(Valor2, 280, 110, textValorPaint);
	}	
	
	
	@Override
	public boolean onTouchEvent(MotionEvent event) {
		// Obtener la posicion relativa
		float x = event.getRawX() - this.getLeft();
		float y = event.getRawY() - this.getTop();
		
		if(y > 100 && y <= 250 && x <= 400){
			if(x < 250){
				listener.onTouchContadorOccurred(this, "Valor1");		
			}
			else{
				listener.onTouchContadorOccurred(this, "Valor2");
			}
		}
		else if(y >= 0 && y <=99 && x <= 400){
			dragListener.onDragContadorOccurred(this, Id);
		}
		
		return super.onTouchEvent(event);
	}
	
	final Runnable Refresh = new Runnable() {
        public void run() {
        	invalidate();
        	requestLayout();
        }
    };
	
	class UpdateTimeTask extends TimerTask {
	   public void run() {
		   
		   RESTClient rClient = new RESTClient(urlServicio);
		   Map<String,String> params = new HashMap<String, String>();
		   params.put("u",usuario);
           params.put("p",password);
           
           String resultado = rClient.webGet(metodo, params);
           
           if(!resultado.isEmpty()){
        	   try {
        		   JSONObject jobj = new JSONObject(resultado);
        		   Valor1 = jobj.getString("Valor1");
        		   Valor2 = jobj.getString("Valor2");
        	   } catch (JSONException e) {
					e.toString();
        	   }
           }
           
           mHandler.post(Refresh);
	   }
	}
}
