package com.sts.businesspanel.entities;

import com.sts.businesspanel.R;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;
import android.app.Activity;

public class DetalleComercialAdapter extends ArrayAdapter<DetalleComercial> {
	Context context; 
    int layoutResourceId;    
    DetalleComercial data[] = null;
    
    public DetalleComercialAdapter(Context context, int layoutResourceId, DetalleComercial[] data) {
        super(context, layoutResourceId, data);
        this.layoutResourceId = layoutResourceId;
        this.context = context;
        this.data = data;
    }
    
    @Override
	public View getView(int position, View convertView, ViewGroup parent) {
    	View row = convertView;
    	DetalleComercialHolder holder = null;
        
        if(row == null)
        {
            LayoutInflater inflater = ((Activity)context).getLayoutInflater();
            row = inflater.inflate(layoutResourceId, parent, false);
            
            holder = new DetalleComercialHolder();
            holder.rowNombre = (TextView)row.findViewById(R.id.rowNombre);
            holder.rowTienda = (TextView)row.findViewById(R.id.rowTienda);
            holder.rowMail = (TextView)row.findViewById(R.id.rowMail);
            holder.rowTelefono = (TextView)row.findViewById(R.id.rowTelefono);
            
            row.setTag(holder);
        }
        else
        {
            holder = (DetalleComercialHolder)row.getTag();
        }
        
        DetalleComercial detalleComercial = data[position];
        holder.rowNombre.setText(detalleComercial.nombre);
        holder.rowTienda.setText(detalleComercial.tienda);
        holder.rowMail.setText(detalleComercial.mail);
        holder.rowTelefono.setText(detalleComercial.telefono);
        
        return row;
		
		
	}
    
    static class DetalleComercialHolder
    {
    	TextView rowNombre;
        TextView rowTienda;
        TextView rowMail;
        TextView rowTelefono;
    }
}
