package com.sts.businesspanel.entities;

import com.sts.businesspanel.R;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;
import android.app.Activity;

public class DetalleTiendaAdapter extends ArrayAdapter<DetalleTienda>{
	Context context; 
    int layoutResourceId;    
    DetalleTienda data[] = null;
    
    public DetalleTiendaAdapter(Context context, int layoutResourceId, DetalleTienda[] data) {
        super(context, layoutResourceId, data);
        this.layoutResourceId = layoutResourceId;
        this.context = context;
        this.data = data;
    }
    
    @Override
	public View getView(int position, View convertView, ViewGroup parent) {
    	View row = convertView;
    	DetalleTiendaHolder holder = null;
        
        if(row == null)
        {
            LayoutInflater inflater = ((Activity)context).getLayoutInflater();
            row = inflater.inflate(layoutResourceId, parent, false);
            
            holder = new DetalleTiendaHolder();
            holder.rowNombre = (TextView)row.findViewById(R.id.rowTiendaNombre);
            holder.rowResponsable = (TextView)row.findViewById(R.id.rowTiendaResponsable);
            holder.rowMail = (TextView)row.findViewById(R.id.rowTiendaMail);
            holder.rowTelefono = (TextView)row.findViewById(R.id.rowTiendaTelefono);
            
            row.setTag(holder);
        }
        else
        {
            holder = (DetalleTiendaHolder)row.getTag();
        }
        
        DetalleTienda detalleTienda = data[position];
        holder.rowNombre.setText(detalleTienda.nombre);
        holder.rowResponsable.setText(detalleTienda.responsable);
        holder.rowMail.setText(detalleTienda.mail);
        holder.rowTelefono.setText(detalleTienda.telefono);
        
        return row;
	}
    
    static class DetalleTiendaHolder
    {
    	TextView rowNombre;
        TextView rowResponsable;
        TextView rowMail;
        TextView rowTelefono;
    }
}
