using System;
using System.Runtime.Serialization;
using BusinessPanelDatos.Entities.Enums;

namespace BusinessPanelDatos.Repository.BaseEntities
{
    [DataContract]
    public abstract class BaseEntidad
    {
        [DataMember]
        public RowState RowState;

        [DataMember]
        public Int32 InternalID;

        public virtual void UpdateOnSubmit()
        {
            if (this.RowState == RowState.Unchanged)
                this.RowState = RowState.Modified;
        }

        public void DeleteOnSubmit()
        {
            this.RowState = RowState.Deleted;
        }
    }
}