IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'D_Buscar_Comercial')
	BEGIN
		DROP  Procedure  D_Buscar_Comercial
	END
GO

CREATE Procedure D_Buscar_Comercial
(
	@pattern AS VARCHAR(200)
)
AS

SELECT e.Nombre, e.Apellido1, e.Apellido2, e.Email, e.Movil, t.Descripcion as TiendaDescripcion
FROM D_Empleados e
		INNER JOIN D_EmpleadosTienda et ON e.Id = et.IdEmpleado
		INNER JOIN C_Tiendas t ON t.Id = et.IdTienda
WHERE (LOWER(e.Nombre) LIKE ('%' + LOWER(@pattern) + '%') OR
	  LOWER(e.Apellido1) LIKE ('%' + LOWER(@pattern) + '%') OR
	  LOWER(e.Apellido2) LIKE ('%' + LOWER(@pattern) + '%'))