IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'D_Obtener_Comerciales_Conectados')
	BEGIN
		DROP  Procedure  D_Obtener_Comerciales_Conectados
	END
GO

CREATE Procedure D_Obtener_Comerciales_Conectados
(
	@fecha AS DATETIME
)
AS

SELECT e.Nombre, e.Apellido1, e.Apellido2, t.Descripcion, e.Email, e.Movil
FROM D_Empleados e
	INNER JOIN D_EmpleadosTienda et ON e.Id = et.IdEmpleado
	INNER JOIN C_Tiendas t ON t.Id = et.IdTienda
WHERE e.Id IN (SELECT IdEmpleado 
					FROM D_RegistroEmpleados 
					WHERE DAY(FechaRegistro) = DAY(@fecha) AND
						  MONTH(FechaRegistro) = MONTH(@fecha) AND
						  YEAR(FechaRegistro) = YEAR(@fecha))