IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'D_Obtener_Tiendas_Con_Ventas')
	BEGIN
		DROP  Procedure  D_Obtener_Tiendas_Con_Ventas
	END
GO

CREATE Procedure D_Obtener_Tiendas_Con_Ventas
(
	@fecha AS DATETIME
)
AS

SELECT t.Descripcion, e.Nombre, e.Apellido1, e.Apellido2, e.Email, e.Movil
FROM C_Tiendas t 
		INNER JOIN D_Tienda_Responsable tr ON t.Id = tr.IdTienda
		INNER JOIN D_Empleados e ON tr.IdResponsable = e.Id
WHERE t.Id IN (SELECT IdTienda FROM D_Tienda_Ventas WHERE DAY(Fecha) = DAY(@fecha) AND MONTH(Fecha) = MONTH(@fecha) AND YEAR(Fecha) = YEAR(@fecha))