﻿using System;
using System.ServiceModel.Activation;
using BusinessPanelDatos.Entities;
using BusinessPanelDatos.Repository;

namespace BusinessPanelWCF
{
    // NOTA: puede usar el comando "Rename" del menú "Refactorizar" para cambiar el nombre de clase "BusinessPanelService" en el código, en svc y en el archivo de configuración.
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class BusinessPanelService : IBusinessPanelService
    {
        private BusinessPanelRepostory _repostory;

        public DatosUsuario ObtenerDatosUsuario(string u, string p)
        {
            if (Seguridad.Autenticar(u, p))
            {
                _repostory = new BusinessPanelRepostory();
                return _repostory.ObtenerDatosUsuario(u, p);
            }

            return null;
        }

        public ContadorSimpleEntity ObtenerDisponibilidadComerciales(string u, string p)
        {
            if (Seguridad.Autenticar(u, p))
            {
                _repostory = new BusinessPanelRepostory();
                return _repostory.ObtenerDisponibilidadComerciales(DateTime.Now);    
            }

            return null;
        }

        public DatosComercial[] ObtenerComercialesConectados(string u, string p)
        {
            if (Seguridad.Autenticar(u, p))
            {
                _repostory = new BusinessPanelRepostory();
                return _repostory.ObtenerComercialesConectados();
            }

            return null;
        }

        public DatosComercial[] ObtenerComercialesBaja(string u, string p)
        {
            if (Seguridad.Autenticar(u, p))
            {
                _repostory = new BusinessPanelRepostory();
                return _repostory.ObtenerComercialesBaja();
            }

            return null;
        }

        public ContadorSimpleEntity ObtenerVentasTotalesTiendas(string u, string p)
        {
            if (Seguridad.Autenticar(u, p))
            {
                _repostory = new BusinessPanelRepostory();
                return _repostory.ObtenerVentasTotalesTiendas(DateTime.Now);
            }

            return null;
        }

        public DatosTienda[] ObtenerTiendasConVentas(string u, string p)
        {
            if (Seguridad.Autenticar(u, p))
            {
                _repostory = new BusinessPanelRepostory();
                return _repostory.ObtenerTiendasConVentas();
            }

            return null;
        }

        public DatosTienda[] ObtenerTiendasSinVentas(string u, string p)
        {
            if (Seguridad.Autenticar(u, p))
            {
                _repostory = new BusinessPanelRepostory();
                return _repostory.ObtenerTiendasSinVentas();
            }

            return null;
        }

        public DatosComercial[] BuscarComercial(string u, string p, string pattern)
        {
            if (Seguridad.Autenticar(u, p))
            {
                _repostory = new BusinessPanelRepostory();
                return _repostory.BuscarComercial(pattern);
            }

            return null;
        }

        public Ventas[] ObtenerVentasMes(string u, string p)
        {
            if (Seguridad.Autenticar(u, p))
            {
                _repostory = new BusinessPanelRepostory();
                return _repostory.ObtenerVentasPorMes(DateTime.Now);
            }

            return null;
        }

        public Widget[] ObtenerConfiguracionWidgets(string u, string p)
        {
            if (Seguridad.Autenticar(u, p))
            {
                _repostory = new BusinessPanelRepostory();
                return _repostory.ObtenerConfiguracionWidgets(u, p);
            }

            return null;
        }

        public void GuardarConfiguracion(ConfigurationEntity conf)
        {
            if (Seguridad.Autenticar(conf.Usuario, conf.Password))
            {
                _repostory = new BusinessPanelRepostory();
                _repostory.GuardarConfiguracion(conf.Usuario, conf.Password, conf.Orden);
            }
        }
    }
}
