﻿using System.ServiceModel;
using System.ServiceModel.Web;
using BusinessPanelDatos.Entities;

namespace BusinessPanelWCF
{
    // NOTA: puede usar el comando "Rename" del menú "Refactorizar" para cambiar el nombre de interfaz "IBusinessPanelService" en el código y en el archivo de configuración a la vez.
    [ServiceContract]
    public interface IBusinessPanelService
    {
        [OperationContract]
        [WebGet(UriTemplate = "ObtenerDatosUsuario?u={u}&p={p}", BodyStyle = WebMessageBodyStyle.Bare, ResponseFormat = WebMessageFormat.Json)]
        DatosUsuario ObtenerDatosUsuario(string u, string p);

        [OperationContract]
        [WebGet(UriTemplate = "ObtenerDisponibilidadComerciales?u={u}&p={p}", BodyStyle = WebMessageBodyStyle.Bare, ResponseFormat = WebMessageFormat.Json)]
        ContadorSimpleEntity ObtenerDisponibilidadComerciales(string u, string p);

        [OperationContract]
        [WebGet(UriTemplate = "ObtenerComercialesConectados?u={u}&p={p}", BodyStyle = WebMessageBodyStyle.Bare, ResponseFormat = WebMessageFormat.Json)]
        DatosComercial[] ObtenerComercialesConectados(string u, string p);

        [OperationContract]
        [WebGet(UriTemplate = "ObtenerComercialesBaja?u={u}&p={p}", BodyStyle = WebMessageBodyStyle.Bare, ResponseFormat = WebMessageFormat.Json)]
        DatosComercial[] ObtenerComercialesBaja(string u, string p);

        [OperationContract]
        [WebGet(UriTemplate = "ObtenerVentasTotalesTiendas?u={u}&p={p}", BodyStyle = WebMessageBodyStyle.Bare, ResponseFormat = WebMessageFormat.Json)]
        ContadorSimpleEntity ObtenerVentasTotalesTiendas(string u, string p);

        [OperationContract]
        [WebGet(UriTemplate = "ObtenerTiendasConVentas?u={u}&p={p}", BodyStyle = WebMessageBodyStyle.Bare, ResponseFormat = WebMessageFormat.Json)]
        DatosTienda[] ObtenerTiendasConVentas(string u, string p);

        [OperationContract]
        [WebGet(UriTemplate = "ObtenerTiendasSinVentas?u={u}&p={p}", BodyStyle = WebMessageBodyStyle.Bare, ResponseFormat = WebMessageFormat.Json)]
        DatosTienda[] ObtenerTiendasSinVentas(string u, string p);

        [OperationContract]
        [WebGet(UriTemplate = "BuscarComercial?u={u}&p={p}&pattern={pattern}", BodyStyle = WebMessageBodyStyle.Bare, ResponseFormat = WebMessageFormat.Json)]
        DatosComercial[] BuscarComercial(string u, string p, string pattern);

        [OperationContract]
        [WebGet(UriTemplate = "ObtenerVentasMes?u={u}&p={p}", BodyStyle = WebMessageBodyStyle.Bare, ResponseFormat = WebMessageFormat.Json)]
        Ventas[] ObtenerVentasMes(string u, string p);

        [OperationContract]
        [WebGet(UriTemplate = "ObtenerConfiguracionWidgets?u={u}&p={p}", BodyStyle = WebMessageBodyStyle.Bare, ResponseFormat = WebMessageFormat.Json)]
        Widget[] ObtenerConfiguracionWidgets(string u, string p);

        [OperationContract]
        [WebInvoke(UriTemplate = "GuardarConfiguracion", Method = "POST")]
        void GuardarConfiguracion(ConfigurationEntity conf);
    }
}
